=begin
(c) Pavel Tobiáš 2013

Disclaimer
Tento program je ABSOLUTNĚ BEZ ZÁRUKY.

Licence
Tento program podléhá licenci Creative Commons Uveďte autora-Nevyužívejte dílo komerčně-Zachovejte licenci 3.0 Česko (CC BY-NC-SA 3.0 CZ)
Informace o licenci: http://creativecommons.org/licenses/by-nc-sa/3.0/cz/

Základní informace
Autor - Pavel Tobiáš 
Organizace - Tento program vznikl v rámci diplomové práce na ČVUT v Praze, Fakultě stavební
Název - TIS
Verze SU - 2013, 8, (7)

Popis
Plugin slouží pro nastavování a prohlížení dalších informací o objektech modelu. 
=end

#encoding: UTF-8
#Nové submenu a položky v něm
nove_submenu = UI.menu("Plugins").add_submenu("TIS")

vyber = nove_submenu.add_item("Výběr") {
Sketchup.active_model.select_tool( Vyber.new )}

nastaveni = nove_submenu.add_item("Nastavení") {
Sketchup.active_model.select_tool( Nastaveni.new)}

tabulka = nove_submenu.add_item("Tabulka") {
Sketchup.active_model.select_tool( Tabulka.new )}

prehled = nove_submenu.add_item("Přehled atributů") {
Sketchup.active_model.select_tool( PrehledAtributu.new )}

navod = nove_submenu.add_item("Návod (pdf)") {
navod_url = Sketchup.find_support_file("navod.pdf", "Plugins/TIS/")
UI.openURL navod_url
}

about = nove_submenu.add_item("O pluginu") {
zprava = '(c) Pavel Tobiáš 2013' + "\n" + "\n" +
'Disclaimer' + "\n" +
'Tento program je ABSOLUTNĚ BEZ ZÁRUKY.' + "\n" + "\n" +
'Licence' + "\n" +
'Tento program podléhá licenci Creative Commons Uveďte autora-Nevyužívejte dílo komerčně-Zachovejte licenci 3.0 Česko (CC BY-NC-SA 3.0 CZ)' + "\n" +
'Informace o licenci: http://creativecommons.org/licenses/by-nc-sa/3.0/cz/' + "\n" + "\n" +
'Základní informace' + "\n" +
'Autor - Pavel Tobiáš' + "\n" +
'Organizace - Tento program vznikl v rámci diplomové práce na ČVUT v Praze, Fakultě stavební' + "\n" +
'Název - TIS' + "\n" +
'Verze SU - 2013, 8, (7)' + "\n" +  "\n" + 
'Popis' + "\n" +
'Plugin slouží pro nastavování a prohlížení dalších informací o objektech modelu.' + "\n" 
UI.messagebox zprava, MB_MULTILINE, "Plugin TIS"}

#Novy toolbar

panel_nastroju = UI::Toolbar.new "TIS" 

vyber_command = UI::Command.new("Výběr") {
Sketchup.active_model.select_tool( Vyber.new )}
vyber_command.large_icon = "vyber_24.png"
vyber_command.small_icon = "vyber.png"
vyber_command.tooltip = "Výběr"
vyber_command.status_bar_text = "Kliknutim na vybraný objekt zobrazíte další informace" ;

panel_nastroju.add_item vyber_command

tabulka_command = UI::Command.new("Tabulka") {
	Sketchup.active_model.select_tool(Tabulka.new )}
tabulka_command.large_icon = "tabulka_24.png"
tabulka_command.small_icon = "tabulka.png"
tabulka_command.tooltip = "Tabulka"
tabulka_command.status_bar_text = "Souhrnný přehled objektů s atributy"

panel_nastroju.add_item tabulka_command

nastaveni_command = UI::Command.new("Nastavení") {
Sketchup.active_model.select_tool( Nastaveni.new )}
nastaveni_command.large_icon = "nastaveni_24.png"
nastaveni_command.small_icon = "nastaveni.png"
nastaveni_command.tooltip = "Nastavení" #zobrazí se ve žlutém rámečku při vybírání nástroje
nastaveni_command.status_bar_text = "Nastavení atributů objektu" #zobrazí se stavovém řádku SketchUpu

panel_nastroju.add_separator #oddělovač na panelu nástrojů
panel_nastroju.add_item nastaveni_command #přidání tlačítka na panel nástrojů
panel_nastroju.show #zobrazení panelu nástrojů

#Vytvorime kurzory

cursor_path = Sketchup.find_support_file("kurzor.png", "Plugins/TIS/") #soubor png kurzoru
@@cursor_vyber_id = UI.create_cursor(cursor_path, 10, 2) #cisla jsou souradnice vztazneho bodu "hotpoint" kurzoru 

cursor_path_nastaveni = Sketchup.find_support_file("kurzor_nastaveni.png", "Plugins/TIS/")
@@cursor_nastaveni_id = UI.create_cursor(cursor_path_nastaveni, 10, 2)

#Vytvorime novy WebDialog
#pro zobrazovani podrobnosti o objektech
@@wd_podrobnosti=UI::WebDialog.new(             
			"Podrobnosti o objektu", true, "",  #název, scrollable?
			360, 700, 700, 100, true )          #rozměry a pozice, resizable?

@@wd_podrobnosti.set_size(360,700)	
@@wd_podrobnosti.set_position(700,100)			
			
@@wd_tabulka=UI::WebDialog.new( 
			"Objekty s atributy", true, "", 
			360, 700, 100,100, true ) #pro zobrazeni souhrnne tabulky
			
@@wd_tabulka.set_size(360,700)	
@@wd_tabulka.set_position(1060,100)			
			
@@wd_kamera=UI::WebDialog.new(
			"Nastavení kamery", true, "", 
			400, 150, 700,200, false ) #pro nastaveni kamery
			
@@wd_kamera.set_size(400,150)	
@@wd_kamera.set_position(700,200)	

#Observer sledující otevírání nových modelů
class ApplicationObserver 
	def onNewModel(model)
		if	@@wd_tabulka.visible? == true 
			Sketchup.active_model.select_tool(Tabulka.new)
			Sketchup.send_action "selectSelectionTool:"
		end #if	@@wd_tabulka.visible?
		Sketchup.active_model.add_observer(ActivePathObserver.new)	
	end #onNewModel(model)
	   
	def onOpenModel(model)
        if	@@wd_tabulka.visible? == true 
			Sketchup.active_model.select_tool(Tabulka.new)
			Sketchup.send_action "selectSelectionTool:"
		end #if	@@wd_tabulka.visible?
		Sketchup.active_model.add_observer(ActivePathObserver.new)	
	end #onOpenModel(model)
end #class ApplicationObserver 

Sketchup.add_observer(ApplicationObserver.new)

#Observer sledující otevírání komponent a skupin pro editaci
class ActivePathObserver
	def onActivePathChanged(model)
	#pokud je videt souhrnny prehled, obnovime tabulku
		if	@@wd_tabulka.visible? == true 
			Sketchup.active_model.select_tool(Tabulka.new)
			Sketchup.send_action "selectSelectionTool:"
		end #if	@@wd_tabulka.visible?
	end #onActivePathChanged
 end #class ActivePathObserver

Sketchup.active_model.add_observer(ActivePathObserver.new)	
	
class Vyber #Nástroj pro výběr objektu a zobrazení dalších informací

def onSetCursor #Nejprve vytvoříme kurzor
	cursor = UI.set_cursor(@@cursor_vyber_id)
end #def onSetCursor

def onMouseMove(flags, x, y, view) #pokud se myš pohybuje
	
    Sketchup.set_status_text "Ctrl + levé tlačítko = zvýraznění objektů s atributy",SB_PROMPT
    Sketchup.active_model.selection.clear #vymazeme dosavadni vyber
	
	#Výběr
	ph = view.pick_helper
	ph.do_pick x,y
	best = ph.best_picked

	if best != nil #pokud bylo něco vybráno
		slovniky = best.attribute_dictionaries #všechny slovníky entity
		
		if slovniky != nil #pokud má objekt přiřazeny atributy
			if slovniky["SlovnikTIS"] != nil   #pokud má objekt přiřazeny atributy v našem slovníku
				slovnik = slovniky["SlovnikTIS"] #vybereme slovník
				view.tooltip = "Tento objekt obsahuje další informace" #zobrazíme text vedle kurzoru
				Sketchup.set_status_text "Kliknutím na objekt získáte další informace", SB_PROMPT #zobrazíme nápovědu ve stavovém řádku
				Sketchup.active_model.selection.toggle(best) #přidání do selekce, zvýraznění		
			end #if slovniky["SlovnikTIS"] != nil 
		end #if slovniky != nil
	end  #if best != nil
    
end #onMouseMove(flags, x, y, view)

@@ctrl = false #ctrl není zmáčknuto

def onLButtonDown(flags, x, y, view) #při kliknutí levým tlačítkem

	if	@@ctrl == false #není-li zároveň zmáčknuta klávesa ctrl

		Sketchup.active_model.selection.clear #Vymažeme dosavadní výběr
			
		#Výběr
		ph = view.pick_helper
		ph.do_pick x,y
		best = ph.best_picked
		
		if best != nil	#pokud bylo něco vybráno
			Sketchup.active_model.selection.toggle(best) #přidání do selekce, zvýraznění
			slovniky = best.attribute_dictionaries #vsechny slovniky entity
			
			if slovniky != nil #pokud má objekt přiřazeny atributy
				if slovniky["SlovnikTIS"] != nil   #pokud má objekt přiřazeny atributy v našem slovníku
					slovnik = slovniky["SlovnikTIS"] #vybereme slovník
					if slovnik["Nazev"] != nil
						nazev = '<h3>'+slovnik["Nazev"]+'</h3><hr>'
					else
						nazev = ''
					end #if slovnik["Nazev"] != nil
					
					if slovnik["Obrazek"] != nil
						obr = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Obrazek"]
						obrazek = '<a href="skp:soubor@'+slovnik["Obrazek"]+'"><img src="'+obr+'" alt="Obrazek" height="150px"  border="0"><br>Klikněte pro zvětšení</a><hr>'
					else
						obrazek = ''
					end #if slovnik["Obrazek"] != nil
				
					if slovnik["Model"] != nil
						plugin_path = File.dirname(__FILE__) 
						mod = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Model"]
						if File.file?(mod) == true #pokud existuje soubor s modelem
							model = '<a href="skp:soubor@'+slovnik["Model"]+'"><img src="'+plugin_path+'/logo.png" alt="Obrazek" height="50px"  border="0"><br>Klikněte pro otevření samostatného modelu</a><hr>'
						else
							model = '<center><b><font color="red">Nenalezen soubor samostatného modelu!</b></font></center><hr>'
						end #if File.file?(mod) == true 
					else
						model = ''
					end #if slovnik["Model"] != nil
					
					if slovnik["Popis"] != nil
						pop = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Popis"]

						if File.file?(pop) == true #pokud existuje soubor s popisem 
							popis = File.read(pop)
						else
							popis = '<center><b><font color="red">Nenalezen soubor s popisem!</b></font></center>'
						end #File.file?(pop) == true
					else
						popis = ''
					end #if slovnik["Model"] != nil
					
					#Pokud je vybraný objekt komponenta/skupina, zjistím, zda se uvnitř nenachází další objekty s informacemi
					
					objekty_uvnitr_text = ''
					
					if best.class == Sketchup::ComponentInstance #Pokud je vybrána komponenta
						objekty_uvnitr = false
						nazvy = '' #Názvy objektů s atributy uvnitř komponenty
						definice_komponenty = best.definition #zjistíme definici dané instance komponenty
						objekty_komponenty = definice_komponenty.entities
						#projdeme všechny entity v rámci komponenty
						objekty_komponenty.each{|objekt|
							slovniky = objekt.attribute_dictionaries #vsechny slovníky entity
							if slovniky != nil #pokud ma entita přiřazeny atributy
			 					if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
									objekty_uvnitr = true
									if slovniky["SlovnikTIS"]["Nazev"] != nil
										nazvy = nazvy + slovniky["SlovnikTIS"]["Nazev"] + ','
									else
										nazvy = nazvy +'nepojmenováno,'
									end #if slovniky["SlovnikTIS"]["Nazev"] != nil
								end  #if slovniky["SlovnikTIS"] != nil      
							end} # slovniky != nil
						if objekty_uvnitr == true
							objekty_uvnitr_text = 'Uvnitř této komponenty se nachází další objekty s informacemi: '+nazvy+'<br>Komponentu otevřete dvojklikem nástrojem <b>Select</b><hr>'
						else
							objekty_uvnitr_text = ''
						end #objekty_uvnitr = true
						
					elsif best.class == Sketchup::Group	#Pokud jsme ve skupině
						objekty_uvnitr = false
						nazvy = '' #Názvy objektů s atributy uvnitř skupiny
						objekty_skupiny = best.entities
						#projdeme všechny entity v rámci skupiny
						objekty_skupiny.each{|objekt|
							slovniky = objekt.attribute_dictionaries #všechny slovníky entity
							if slovniky != nil #pokud má entita přiřazeny atributy
								if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
									objekty_uvnitr = true
									if slovniky["SlovnikTIS"]["Nazev"] != nil
										nazvy = nazvy +slovniky["SlovnikTIS"]["Nazev"] + ','
									else
										nazvy = nazvy +'nepojmenováno,'
									end #if slovniky["SlovnikTIS"]["Nazev"] != nil
								end  #if slovniky["SlovnikTIS"] != nil      
							end} # slovniky != nil
						if objekty_uvnitr == true
							objekty_uvnitr_text = 'Uvnitř této skupiny se nachází další objekty s informacemi: '+nazvy+'<br>Skupinu otevřete dvojklikem nástrojem <b>Select</b><hr>'
						else
							objekty_uvnitr_text = ''
						end #objekty_uvnitr = true
					end #if nadrazena_trida.class == Sketchup::ComponentInstance
					
					#vygenerujeme webovou stránku
					html= '<!DOCTYPE html>
					<html>
					<head>
					<meta http-equiv="Content-Language" content="cs">
					<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
					</head>
					<body>'+nazev+
					'<center>'+
					obrazek+
					'</center>'+
					objekty_uvnitr_text+
					'<center>'+
					model+
					'</center>'+
					popis+
					'</body>
					</html>'
			
					@@wd_podrobnosti.set_html(html)
					
					#Callback pro otevírání souborů
					
					@@wd_podrobnosti.add_action_callback("soubor") do |js_wd, zprava|
						soubor = File.dirname(Sketchup.active_model.path)+"/"+zprava
						if File.file?(soubor) == true #pokud existuje soubor 
							UI.openURL soubor
						else
							UI.messagebox "Soubor, na který je odkazováno, neexistuje!"
						end #if File.file?(soubor)
					end #@@wd_kamera.add_action_callback
					
					if @@wd_podrobnosti.visible? == false
						@@wd_podrobnosti.show()
					end #if web_dialog.visible?
					
				else
					UI.messagebox "Tento objekt neobsahuje další informace"
				end #slovniky["SlovnikTIS"] != nil 
			
			else
				UI.messagebox "Tento objekt neobsahuje další informace"
			end #slovniky != nil
					
		end #if best != nil	
	
	else #pokud je zároveň zmáčknuta klávesa ctrl zvýrazníme objekty s atributy
		objekty = Sketchup.active_model.entities
	
		if Sketchup.active_model.active_path == nil #pokud není otevřena žádná komponenta pro editaci
			#projdeme všechny entity v rámci modelu
			objekty.each{|objekt|
			slovniky = objekt.attribute_dictionaries #všechny slovníky entity
			if slovniky != nil #pokud má entita přiřazeny atributy
				if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
					Sketchup.active_model.selection.add objekt
				end  #if slovniky["SlovnikTIS"] != nil      
			end} # slovniky != nil
		
		else #pokud je komponenta (či skupina) otevřena pro editaci
			pocet_urovni = Sketchup.active_model.active_path.length
			nadrazena_trida = Sketchup.active_model.active_path[pocet_urovni-1]
		
			if nadrazena_trida.class == Sketchup::ComponentInstance #pokud jsme v komponentě
				definice_komponenty = nadrazena_trida.definition
				objekty_komponenty = definice_komponenty.entities
				#projdeme všechny entity v rámci komponenty
				objekty_komponenty.each{|objekt|
					slovniky = objekt.attribute_dictionaries #všechny slovníky entity
						if slovniky != nil #pokud ma entita priřazeny atributy
							if slovniky["SlovnikTIS"] != nil   #pokud ma entita priřazeny atributy v našem slovníku
								Sketchup.active_model.selection.add objekt
							end  #if slovniky["SlovnikTIS"] != nil      
						end} # slovniky != nil
						
			else	#Pokud jsme ve skupině
				objekty_skupiny = nadrazena_trida.entities
				#projdeme všechny entity v rámci skupiny
				objekty_skupiny.each{|objekt|
					slovniky = objekt.attribute_dictionaries #všechny slovníky entity
						if slovniky != nil #pokud ma entita priřazeny atributy
							if slovniky["SlovnikTIS"] != nil   #pokud ma entita priřazeny atributy v našem slovníku
							Sketchup.active_model.selection.add objekt
						end  #if slovniky["SlovnikTIS"] != nil      
				end} # slovniky != nil
			
			end #if nadrazena_trida.class == Sketchup::ComponentInstance
		end #if Sketchup.active_model.active_path == nil		
	
	end	#@ctrl == false
end #onLButtonDown

def onKeyDown(key, repeat, flags, view) #pokud je zmáčknuta klavesa control
	if key == VK_CONTROL 
		@@ctrl = true
     end
end

def onKeyUp(key, repeat, flags, view) #pokud je puštěna klávesa control
   if key == VK_CONTROL 
		@@ctrl = false
   end
 end

end #class

class Nastaveni #Nástroj pro nastavení atributů

def onSetCursor #Nejprve vytvoříme kurzor
	cursor = UI.set_cursor(@@cursor_nastaveni_id)
end #def onSetCursor

def activate
	result = Sketchup.set_status_text "Klikněte pro nastavení atributů", SB_PROMPT #zobrazíme nápovědu ve stavovém řádku
end #activate

def resume(view) 
	result = Sketchup.set_status_text "Klikněte pro nastavení atributů", SB_PROMPT #zobrazíme nápovědu ve stavovém řádku
end #resume

def onLButtonDown(flags, x, y, view) #při kliknutí levým tlačítkem

	def nastaveniKamery(best) #funkce pro nastavení kamery

		@@wd_kamera.add_action_callback("kamera") do |js_wd, zprava|
			kamera = Sketchup.active_model.active_view.camera
			eye = kamera.eye
			target = kamera.target
			up = kamera.up
			kamera_vektor = [eye,target,up]
			best.set_attribute "SlovnikTIS","Kamera",kamera_vektor
			
			if	@@wd_tabulka.visible? == true #pokud je vidět souhrnný přehled, obnovíme tabulku
				Sketchup.active_model.select_tool(Tabulka.new) 
				Sketchup.active_model.select_tool(Nastaveni.new) 
			end
			
			@@wd_kamera.close					
		end #@@wd_kamera.add_action_callback
		
		#zjistíme název objektu
		
		nazev = best.get_attribute "SlovnikTIS", "Nazev"
		
		if nazev == nil
			nazev = "nepojmenovano"
		end #if nazev = nil
		
		#vygenerujeme webovou stránku
		html= '<!DOCTYPE html>
			<html>
			<head>
			<meta http-equiv="Content-Language" content="cs">
			<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
			</head>
			<body bgcolor="rgb(232,232,232)">
			<center>
			<b>Nastavte pohled kamery na objekt "'+nazev+'" a&nbspstiskněte OK</b>
			<p>
			<button style="border: 2px solid gray;
			background-color: rgb(232,232,232)"
			onclick="tlacitko()"
			>&nbsp;&nbsp;&nbsp;&nbsp;&nbspOK&nbsp;&nbsp&nbsp;&nbsp&nbsp;</button>
			</center>
			<script type="text/javascript">
			function tlacitko() {window.location.href = "skp:kamera@ok"}
			</script>
			</body>
			</html>'
		@@wd_kamera.set_html(html)
		@@wd_kamera.show	
					
	end	
	
	Sketchup.active_model.selection.clear #Vymazeme dosavadni vyber
		
    #Výběr
	ph = view.pick_helper
	ph.do_pick x,y
	best = ph.best_picked
	 
	if best != nil #je-li vybrán nějaký objekt
	
		Sketchup.active_model.selection.toggle(best) #přidání do selekce, zvýraznění
		
		slovniky = best.attribute_dictionaries #vsechny slovníky entity		
		if slovniky != nil #pokud má entita přiřazeny atributy
		
			if slovniky["SlovnikTIS"] != nil   #pokud ma entita priřazeny atributy v našem slovníku
				slovnik = slovniky["SlovnikTIS"] #vybereme slovník
						
				#Přesunutí pohledu kamery na objekt
				
				kamera_vektor = best.get_attribute "SlovnikTIS","Kamera"
				eye = kamera_vektor[0]
				target = kamera_vektor[1]
				up = kamera_vektor[2]
				kamera = Sketchup::Camera.new
				kamera.set eye,target,up
				Sketchup.active_model.active_view.camera=kamera
							
				#defaultni hodnoty atributu, pokud jsou ulozeny
				if slovnik["Nazev"] != nil
				nazev = slovnik["Nazev"] #ulozen nazev
				else
				nazev = ""	
				end #if slovnik["Nazev"] != nil
				
				if slovnik["Obrazek"] != nil
				obrazek = slovnik["Obrazek"] #ulozen obrazek
				
				else
				obrazek = ""
				end #if slovnik["Obrazek"] != nil
				
				if slovnik["Model"] != nil
				model = slovnik["Model"] #ulozen model
				else
				model = ""		
				end #if slovnik["Model"] != nil
				
				if slovnik["Popis"] != nil
				popis = slovnik["Popis"] #ulozen model
				else
				popis = ""		
				end #if slovnik["Popis"] != nil
				
				#inputbox
				prompts = ["Název objektu:","Obrázek (relativní cesta k obrázku):","Samostatný model (relativní cesta k modelu):","Popis (relativní cesta k souboru s popisem):"]
				defaults = [nazev,obrazek,model,popis]
				input = UI.inputbox prompts, defaults, "Změnit atributy:"
										
				if input[0] != "" && input[0] != slovnik["Nazev"] #pouze pokud změníme název
					best.set_attribute "SlovnikTIS", "Nazev", input[0]
				elsif input[0] == "" && slovnik["Nazev"] != nil #pouze pokud vymažeme název	
					slovnik.delete_key("Nazev")
				end #if input[0]
			
				if input[1] != "" && input[1] != slovnik["Obrazek"] #pouze pokud změníme obrazek
					best.set_attribute "SlovnikTIS", "Obrazek", input[1]
				elsif input[1] == "" && slovnik["Obrazek"] != nil  #pouze pokud vymažeme obrázek
					slovnik.delete_key("Obrazek")
				end # if input[1]
				
				if input[2] != "" && input[2] != slovnik["Model"] #pouze pokud změníme model
					best.set_attribute "SlovnikTIS", "Model", input[2]
				elsif input[2] == "" && slovnik["Model"] != nil  #pouze pokud vymažeme model
					slovnik.delete_key("Model")
				end # if input[2]
				
				if input[3] != "" && input[3] != slovnik["Popis"] #pouze pokud změníme popis
					best.set_attribute "SlovnikTIS", "Popis", input[3]
				elsif input[3] == "" && slovnik["Popis"] != nil  #pouze pokud vymažeme popis
					slovnik.delete_key("Popis")
				end # if input[3]
				#pokud vymažeme vsechny atributy ze slovníku, vymažeme i slovník		
				if input[0] == "" && input[1] == "" && input[2] == "" && input[3] == "" 
					slovniky.delete 'SlovnikTIS'
					if	@@wd_tabulka.visible? == true #pokud je vidět souhrnný přehled, obnovíme tabulku
						Sketchup.active_model.select_tool(Tabulka.new) 
					end
				else
				#Nastavení kamery
					nastaveniKamery(best)
				end #if input[0] == "" && if input[1] == "" && input[2] == "" && input[3] == "" 
				
			else #pokud nemá komponenta atributy v našem slovniku
				prompts = ["Název objektu:","Obrázek (relativní cesta k obrázku):","Samostatný model (relativní cesta k modelu):","Popis (relativní cesta k souboru s popisem):"]
				defaults = ["","","",""] #žádné defaultní hodnoty
				input = UI.inputbox prompts, defaults, "Vložte atributy:"

				if input[0] != ""  #pouze pokud vložíme nějaký název
					best.set_attribute "SlovnikTIS", "Nazev", input[0]
				end #if input[0]
			
				if input[1] != ""	#pouze pokud vložíme nějaký obrázek
					best.set_attribute "SlovnikTIS", "Obrazek", input[1]
				end # if input[1]
				
				if input[2] != ""	#pouze pokud vložíme nějaký model
					best.set_attribute "SlovnikTIS", "Model", input[2]
				end # if input[2]
				
				if input[3] != ""	#pouze pokud vložíme nějaký popis
					best.set_attribute "SlovnikTIS", "Popis", input[3]
				end # if input[3]
				
				#Nastavení kamery
				
				if input[0] != "" || input[1] != "" || input[2] != "" || input[3] != "" #pouze pokud jsme něco vložili
				
					#automatické nastavení (pro případ, že uživatel nastavení neprovede)
					kamera = Sketchup.active_model.active_view.camera
					eye = kamera.eye
					target = kamera.target
					up = kamera.up
					kamera_vektor = [eye,target,up]
					best.set_attribute "SlovnikTIS","Kamera",kamera_vektor

					#nastavení kamery uživatelem
					nastaveniKamery(best)
					
				end #if input[0] != "" || input[1] != "" || input[2] != "" || input[3] != ""
				
			end #if slovniky["SlovnikTIS"]
		
		else #pokud nema komponenta zadne atributy
			prompts = ["Název objektu:","Obrázek (relativní cesta k obrázku):","Samostatný model (relativní cesta k modelu):","Popis (relativní cesta k souboru s popisem):"]
			defaults = ["","","",""] #žádné defaultní hodnoty
			input = UI.inputbox prompts, defaults, "Vložte atributy:"
     
			if input[0] != ""   #pouze pokud vložíme nějaký název
				best.set_attribute "SlovnikTIS", "Nazev", input[0]
			end #if input[0]
		
			if input[1] != ""	#pouze pokud vložíme nějaký obrázek
				best.set_attribute "SlovnikTIS", "Obrazek", input[1]
			end # if input[1]
			
			if input[2] != ""	#pouze pokud vložíme nějaký model
				best.set_attribute "SlovnikTIS", "Model", input[2]
			end # if input[2]
			
			if input[3] != ""	#pouze pokud vložíme nějaký popis
				best.set_attribute "SlovnikTIS", "Popis", input[3]
			end # if input[3]
			
			#Nastaveni kamery
			
			if input[0] != "" || input[1] != "" || input[2] != "" || input[3] != "" #pouze pokud jsme něco vložili
			
				#automatické nastavení (pro případ, že uživatel nastavení neprovede)			
				kamera = Sketchup.active_model.active_view.camera
				eye = kamera.eye
				target = kamera.target
				up = kamera.up
				kamera_vektor = [eye,target,up]
				best.set_attribute "SlovnikTIS","Kamera",kamera_vektor 

				#nastavení kamery uživatelem				
				nastaveniKamery(best)
				
			end #if input[0] != "" || input[1] != "" || input[2] != "" || input[3] != ""
				
		end #if slovniky != nil
	  
	end #if best != nil  
	
end #onLButtonDown

end #class

class Tabulka #Nástroj pro souhrnný přehled objektů s atributy

def activate
	
	objekty_kody = []
	nazvy = []
	obrazky = []
	modely = []
	popisy = []
	kamery = []
	nadrazeny_objekt_nazev = ''
	
	objekty = Sketchup.active_model.entities
	
	if Sketchup.active_model.active_path == nil #pokud není otevřena žádná komponenta
	
		nadrazeny_objekt_nazev = 'hlavního modelu'
		#projdeme všechny entity v rámci modelu
		objekty.each{|objekt|
			slovniky = objekt.attribute_dictionaries #vsechny slovníky entity
			if slovniky != nil #pokud má entita priřazeny atributy
				
				if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
					
					slovnik = slovniky["SlovnikTIS"] #vybereme slovník
					objekty_kody = objekty_kody + [objekt]
					
					if slovnik["Nazev"] != nil
						nazvy= nazvy + [slovnik["Nazev"]] #uložen nazev
					else
						nazvy = nazvy + ["nepojmenováno"]		
					end #if slovnik["Nazev"] != nil
					
					if slovnik["Obrazek"] != nil
						obrazky = obrazky + ["ANO"] #uložen obrázek
					else
						obrazky = obrazky + ["NE"]	
					end #if slovnik["Obrazek"] != nil
					
					if slovnik["Model"] != nil
						modely = modely + ["ANO"] #uložen model
					else
						modely = modely + ["NE"]		
					end #if slovnik["Model"] != nil
					
					if slovnik["Popis"] != nil
						popisy = popisy + ["ANO"] #uložen popis
					else
						popisy = popisy + ["NE"]		
					end #if slovnik["Popis"] != nil
					
					kamery = kamery+[slovnik["Kamera"]] #nastavení kamery
										
				end  #if slovniky["SlovnikTIS"] != nil      
			end} # slovniky != nil
	
	else #pokud je komponenta (či skupina) otevřena pro editaci
	
		pocet_urovni = Sketchup.active_model.active_path.length
		nadrazena_trida = Sketchup.active_model.active_path[pocet_urovni-1]
		if nadrazena_trida.class == Sketchup::ComponentInstance #pokud jsme v komponentě
			nadrazeny_objekt_nazev = 'komponenty '
			#zjistíme název nadřazené komponenty, má-li ho
			slovniky_komponenty = nadrazena_trida.attribute_dictionaries #všechny slovníky nadřazené komponenty
			if slovniky_komponenty != nil #pokud má komponenta přiřazeny atributy
				if slovniky_komponenty["SlovnikTIS"] != nil   #pokud ma komponenta přiřazeny atributy v našem slovniku
					if slovniky_komponenty["SlovnikTIS"]["Nazev"] != nil
						nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + slovniky_komponenty["SlovnikTIS"]["Nazev"] #uložen nazev					
					else
						nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + 'nepojmenováno'
					end #slovniky_komponenty["SlovnikTIS"]["Nazev"] != nil
				else
					nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + 'nepojmenováno'
				end #if slovniky_komponenty["SlovnikTIS"] != nil
			end #if slovniky_komponenty != nil
		
		    definice_komponenty = nadrazena_trida.definition #zjistíme definici dané instance komponenty
			objekty_komponenty = definice_komponenty.entities
		    #projdeme všechny entity v rámci komponenty
			objekty_komponenty.each{|objekt|
				slovniky = objekt.attribute_dictionaries #vsechny slovníky entity
			    if slovniky != nil #pokud ma entita přiřazeny atributy
			 
						if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
							
							slovnik = slovniky["SlovnikTIS"] #vybereme slovnik
							objekty_kody = objekty_kody + [objekt]
							
							if slovnik["Nazev"] != nil
								nazvy= nazvy + [slovnik["Nazev"]] #uložen nazev
							else
								nazvy = nazvy + ["nepojmenováno"]		
							end #if slovnik["Nazev"] != nil
							
							if slovnik["Obrazek"] != nil
								obrazky = obrazky + ["ANO"] #uložen obrázek
							else
								obrazky = obrazky + ["NE"]	
							end #if slovnik["Obrazek"] != nil
							
							if slovnik["Model"] != nil
								modely = modely + ["ANO"] #uložen model
							else
								modely = modely + ["NE"]		
							end #if slovnik["Model"] != nil
							
							if slovnik["Popis"] != nil
								popisy = popisy + ["ANO"] #uložen popis
							else
								popisy = popisy + ["NE"]		
							end #if slovnik["Popis"] != nil
							
							kamery = kamery+[slovnik["Kamera"]] #nastavení kamery
												
						end  #if slovniky["SlovnikTIS"] != nil      
					end} # slovniky != nil
					
		else	#Pokud jsme ve skupine
		
		nadrazeny_objekt_nazev = 'skupiny '
		
		slovniky_skupiny = nadrazena_trida.attribute_dictionaries #vsechny slovniky nadrazene komponenty
		#zjistíme název nadřazené komponenty, má-li ho
		if slovniky_skupiny != nil #pokud má skupina přiřazeny atributy
			if slovniky_skupiny["SlovnikTIS"] != nil   #pokud má skupina přiřazeny atributy v našem slovníku
				if slovniky_skupiny["SlovnikTIS"]["Nazev"] != nil
					nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + slovniky_skupiny["SlovnikTIS"]["Nazev"] #uložen nazev					
				else
					nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + 'nepojmenováno'
				end #slovniky_skupiny["SlovnikTIS"]["Nazev"] != nil
			else
				nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + 'nepojmenováno'
			end #slovniky_komponenty["SlovnikTIS"] != nil
		else
			nadrazeny_objekt_nazev = nadrazeny_objekt_nazev + 'nepojmenováno'
		end #if slovniky != nil
		
			objekty_skupiny = nadrazena_trida.entities
			#projdeme všechny entity v rámci skupiny
			objekty_skupiny.each{|objekt|
				slovniky = objekt.attribute_dictionaries #všechny slovníky entity
				if slovniky != nil #pokud má entita přiřazeny atributy
			
					if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
						
						slovnik = slovniky["SlovnikTIS"] #vybereme slovník
						objekty_kody = objekty_kody + [objekt]
						
						if slovnik["Nazev"] != nil
							nazvy= nazvy + [slovnik["Nazev"]] #uložen název
						else
							nazvy = nazvy + ["nepojmenováno"]		
						end #if slovnik["Nazev"] != nil
						
						if slovnik["Obrazek"] != nil
							obrazky = obrazky + ["ANO"] #uložen obrázek
						else
							obrazky = obrazky + ["NE"]	
						end #if slovnik["Obrazek"] != nil
						
						if slovnik["Model"] != nil
							modely = modely + ["ANO"] #uložen model
						else
							modely = modely + ["NE"]		
						end #if slovnik["Model"] != nil
						
						if slovnik["Popis"] != nil
							popisy = popisy + ["ANO"] #uložen popis
						else
							popisy = popisy + ["NE"]		
						end #if slovnik["Popis"] != nil
						
						kamery = kamery+[slovnik["Kamera"]] #nastavení kamery
											
					end  #if slovniky["SlovnikTIS"] != nil      
				end} # slovniky != nil
		
		end #if nadrazena_trida.class == Sketchup::ComponentInstance
	end #if Sketchup.active_model.active_path == nil

	#callback pro zoomovaní a vybrání objektu
	
	@@wd_tabulka.add_action_callback("zoom_vyber") do |js_wd, zprava|
	poradi = eval(zprava)
	objekt = objekty_kody[poradi]
	Sketchup.active_model.selection.clear
	Sketchup.active_model.selection.add objekt
	kamera_vektor = kamery[poradi]
	eye = kamera_vektor[0]
	target = kamera_vektor[1]
	up = kamera_vektor[2]
	kamera = Sketchup::Camera.new
	kamera.set eye,target,up
	Sketchup.active_model.active_view.camera=kamera
		
	#zobrazíme dodatečné informace (jako při vybráni nástrojem Výběr)
	slovniky = objekt.attribute_dictionaries 
	
		slovnik = slovniky["SlovnikTIS"] #vybereme slovník
	
		if slovnik["Nazev"] != nil
			nazev = '<h3>'+slovnik["Nazev"]+'</h3><hr>'
		else
			nazev = ''
		end #if slovnik["Nazev"] != nil
		
		if slovnik["Obrazek"] != nil
			obr = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Obrazek"]
			obrazek = '<a href="skp:soubor@'+slovnik["Obrazek"]+'"><img src="'+obr+'" alt="Obrazek" height="150px"  border="0"><br>Klikněte pro zvětšení</a><hr>'
		else
			obrazek = ''
		end #if slovnik["Obrazek"] != nil
				
		if slovnik["Model"] != nil
			plugin_path = File.dirname(__FILE__) 
			mod = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Model"]
			if File.file?(mod) == true #pokud existuje soubor s modelem
				model = '<a href="skp:soubor@'+slovnik["Model"]+'"><img src="'+plugin_path+'/logo.png" alt="Obrazek" height="50px"  border="0"><br>Klikněte pro otevření samostatného modelu</a><hr>'
			else
				model = '<center><b><font color="red">Nenalezen soubor samostatného modelu!</b></font></center><hr>'
			end #if File.file?(mod) == true 
		else
			model = ''
		end #if slovnik["Model"] != nil
		
		if slovnik["Popis"] != nil
			pop = File.dirname(Sketchup.active_model.path)+"/"+slovnik["Popis"]

			if File.file?(pop) == true #pokud existuje soubor s popisem 
				popis = File.read(pop)
			else
				popis = '<center><b><font color="red">Nenalezen soubor s popisem!</b></font></center>'
			end #File.file?(pop) == true
		else
			popis = ''
		end #if slovnik["Model"] != nil
		
		#Pokud je vybraný objekt komponenta/skupina, zjistíme, zda se uvnitř nenachází další objekty s informacemi
		
		objekty_uvnitr_text = ''
		
		if objekt.class == Sketchup::ComponentInstance #Pokud je vybrána komponenta
			objekty_uvnitr = false
			nazvy = '' #Názvy objektů s atributy uvnitř komponenty
			definice_komponenty = objekt.definition #zjistíme definici dané instance komponenty
			objekty_komponenty = definice_komponenty.entities
			#projdeme všechny entity v rámci komponenty
			objekty_komponenty.each{|objekt|
				slovniky = objekt.attribute_dictionaries #vsechny slovníky entity
				if slovniky != nil #pokud ma entita přiřazeny atributy
						if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
						objekty_uvnitr = true
						if slovniky["SlovnikTIS"]["Nazev"] != nil
							nazvy = nazvy + slovniky["SlovnikTIS"]["Nazev"] + ','
						else
							nazvy = nazvy +'nepojmenováno,'
						end #if slovniky["SlovnikTIS"]["Nazev"] != nil
					end  #if slovniky["SlovnikTIS"] != nil      
				end} # slovniky != nil
			if objekty_uvnitr == true
				objekty_uvnitr_text = 'Uvnitř této komponenty se nachází další objekty s informacemi: '+nazvy+'<br>Komponentu otevřete dvojklikem nástrojem <b>Select</b><hr>'
			else
				objekty_uvnitr_text = ''
			end #objekty_uvnitr = true
			
		elsif objekt.class == Sketchup::Group	#Pokud jsme ve skupině
			objekty_uvnitr = false
			nazvy = '' #Názvy objektů s atributy uvnitř skupiny
			objekty_skupiny = objekt.entities
			#projdeme všechny entity v rámci skupiny
			objekty_skupiny.each{|objekt|
				slovniky = objekt.attribute_dictionaries #všechny slovníky entity
				if slovniky != nil #pokud má entita přiřazeny atributy
					if slovniky["SlovnikTIS"] != nil   #pokud má entita přiřazeny atributy v našem slovníku
						objekty_uvnitr = true
						if slovniky["SlovnikTIS"]["Nazev"] != nil
							nazvy = nazvy +slovniky["SlovnikTIS"]["Nazev"] + ','
						else
							nazvy = nazvy +'nepojmenováno,'
						end #if slovniky["SlovnikTIS"]["Nazev"] != nil
					end  #if slovniky["SlovnikTIS"] != nil      
				end} # slovniky != nil
			if objekty_uvnitr == true
				objekty_uvnitr_text = 'Uvnitř této skupiny se nachází další objekty s informacemi: '+nazvy+'<br>Skupinu otevřete dvojklikem nástrojem <b>Select</b><hr>'
			else
				objekty_uvnitr_text = ''
			end #objekty_uvnitr = true
		end #if nadrazena_trida.class == Sketchup::ComponentInstance
		
		#vygenerujeme webovou stránku
		html= '<!DOCTYPE html>
		<html>
		<head>
		<meta http-equiv="Content-Language" content="cs">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		</head>
		<body>'+nazev+
		'<center>'+
		obrazek+
		'</center>'+
		objekty_uvnitr_text+
		'<center>'+
		model+
		'</center>'+
		popis+
		'</body>
		</html>'
		
		@@wd_podrobnosti.set_html(html)
		
		#Callback pro otevírání souborů
					
		@@wd_podrobnosti.add_action_callback("soubor") do |js_wd, zprava|
			soubor = File.dirname(Sketchup.active_model.path)+"/"+zprava
			if File.file?(soubor) == true #pokud existuje soubor 
				UI.openURL soubor
			else
				UI.messagebox "Soubor, na který je odkazováno, neexistuje!"
			end #if File.file?(soubor)
		end #@@wd_kamera.add_action_callback
		
		if @@wd_podrobnosti.visible? == false
			@@wd_podrobnosti.show()
		end #if web_dialog.visible?
    	
	end #@@wd_tabulka.add_action_callback("zoom_vyber") do |js_wd, zprava|
	
	#Vlastní tabulka
	tabulka = '<table border="1" bordercolor="White" cellpadding="5" cellspacing="0">'+'<tr bgcolor="#FA5858"><th>Název</th><th>Obrázek</th><th>Model</th><th>Popis</th></tr>'

	pocet = objekty_kody.length - 1
	
	for i in 0..pocet
		nazev = nazvy[i]
		obrazek = obrazky[i]
		model = modely[i] 
		popis = popisy[i]
		kod = objekty_kody[i]
		tabulka = tabulka+'<tr bgcolor="rgb(184,184,184)" ><td><a href="skp:zoom_vyber@'+i.to_s+'">'+nazev+'</a></td><td>'+obrazek+'</td><td>'+model+'</td><td>'+popis+'</td></tr>' 
	end #for i in 0..pocet

	tabulka = tabulka+'</table>'
	wd_tabulka_html = '<!DOCTYPE html>
			<html>
			<head>
			<meta http-equiv="Content-Language" content="cs">
			<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
			<style>
				a:hover    {color: #FA5858}
			</style>
			</head>
			<body>
			<h3>Objekty s dalšími informacemi</h3>
			<h4>V rámci: '+nadrazeny_objekt_nazev+'</h4>
			Pro vyhledávání použijte Ctrl+F</br></br>
			<center>'+tabulka+
			'</center>
			</body>
			</html>'	
	@@wd_tabulka.set_html(wd_tabulka_html)
	
	if @@wd_tabulka.visible? == false
		@@wd_tabulka.show()
	end #if web_dialog.visible?

	end #def activate
end #class Tabulka

class PrehledAtributu #funkce, ktera zobrazi atributy objektu jen tak, jak jsou ulozeny ve slovnicich

def activate
	result = Sketchup.set_status_text "Klikněte pro zobrazení přehledu atributů.", SB_PROMPT #zobrazime napovedu ve status baru
	
end #activate

def resume(view) 
	result = Sketchup.set_status_text "Klikněte pro zobrazení přehledu atributů.", SB_PROMPT #zobrazime napovedu ve status baru
end #resume

def onLButtonDown(flags, x, y, view) #pri kliknuti levym tlacitkem
	Sketchup.active_model.selection.clear #Vymazeme dosavadni vyber
	#Vyber	
	ph = view.pick_helper
	ph.do_pick x,y
	best = ph.best_picked
	
	if best != nil
		Sketchup.active_model.selection.toggle(best)
		slovniky = best.attribute_dictionaries
	    if slovniky != nil
			zprava = 'Dictionary Name / Attribute name / Attribute value' + "\n" + '-------------------------------------------------------------------------------' + "\n"
			slovniky.each{|slovnik|
		    slovnik.each{|nazev,hodnota|
					zprava = zprava + slovnik.name + ' / ' + nazev.to_s + ' / ' + hodnota.to_s + "\n" + '-------------------------------------------------------------------------------' + "\n"}
			}
			UI.messagebox zprava, MB_MULTILINE, "Přehled atributů"
		else
			UI.messagebox 'Objekt nemá přiřazeny žádné atributy', MB_OK
		end #if slovniky != nil
	end #if best != nil
end #onLButtonDown	
end #class PrehledAtributu

